/* tslint:disable */
/* eslint-disable */
/**
 * FastAPI
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface IContainerInfo
 */
export interface IContainerInfo {
    /**
     * 
     * @type {string}
     * @memberof IContainerInfo
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof IContainerInfo
     */
    'image': string;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof IContainerInfo
     */
    'labels': { [key: string]: string; };
    /**
     * 
     * @type {string}
     * @memberof IContainerInfo
     */
    'name': string;
    /**
     * 
     * @type {string}
     * @memberof IContainerInfo
     */
    'short_id': string;
    /**
     * 
     * @type {IContainerStatusEnum}
     * @memberof IContainerInfo
     */
    'status': IContainerStatusEnum;
}


/**
 * 
 * @export
 * @interface IContainerLog
 */
export interface IContainerLog {
    /**
     * 
     * @type {string}
     * @memberof IContainerLog
     */
    'logs': string;
    /**
     * 
     * @type {number}
     * @memberof IContainerLog
     */
    'since': number;
}
/**
 * An enumeration.
 * @export
 * @enum {string}
 */

export const IContainerStatusEnum = {
    Running: 'running',
    Created: 'created',
    Restarting: 'restarting',
    Removing: 'removing',
    Paused: 'paused',
    Exited: 'exited',
    Dead: 'dead',
    Unknown: 'unknown'
} as const;

export type IContainerStatusEnum = typeof IContainerStatusEnum[keyof typeof IContainerStatusEnum];


/**
 * 
 * @export
 * @interface IDummyItem
 */
export interface IDummyItem {
    /**
     * 
     * @type {string}
     * @memberof IDummyItem
     */
    'title': string;
}
/**
 * 
 * @export
 * @interface IHTTPValidationError
 */
export interface IHTTPValidationError {
    /**
     * 
     * @type {Array<IValidationError>}
     * @memberof IHTTPValidationError
     */
    'detail'?: Array<IValidationError>;
}
/**
 * 
 * @export
 * @interface ILocationInner
 */
export interface ILocationInner {
}
/**
 * 
 * @export
 * @interface IModelFolder
 */
export interface IModelFolder {
    /**
     * 
     * @type {string}
     * @memberof IModelFolder
     */
    'name': string;
    /**
     * 
     * @type {string}
     * @memberof IModelFolder
     */
    'path': string;
    /**
     * 
     * @type {number}
     * @memberof IModelFolder
     */
    'file_count': number;
    /**
     * 
     * @type {string}
     * @memberof IModelFolder
     */
    'download_link': string;
}
/**
 * 
 * @export
 * @interface IRecordingFolder
 */
export interface IRecordingFolder {
    /**
     * 
     * @type {string}
     * @memberof IRecordingFolder
     */
    'name': string;
    /**
     * 
     * @type {string}
     * @memberof IRecordingFolder
     */
    'path': string;
    /**
     * 
     * @type {number}
     * @memberof IRecordingFolder
     */
    'file_count': number;
    /**
     * 
     * @type {string}
     * @memberof IRecordingFolder
     */
    'download_link': string;
}
/**
 * 
 * @export
 * @interface IStatusInfo
 */
export interface IStatusInfo {
    /**
     * 
     * @type {boolean}
     * @memberof IStatusInfo
     */
    'self_driving'?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof IStatusInfo
     */
    'training_mode'?: boolean;
    /**
     * 
     * @type {string}
     * @memberof IStatusInfo
     */
    'model'?: string;
    /**
     * 
     * @type {boolean}
     * @memberof IStatusInfo
     */
    'emergency_stop'?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof IStatusInfo
     */
    'reset_emergency'?: boolean;
    /**
     * 
     * @type {number}
     * @memberof IStatusInfo
     */
    'initial_recording_switch_state'?: number;
    /**
     * 
     * @type {boolean}
     * @memberof IStatusInfo
     */
    'is_recording'?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof IStatusInfo
     */
    'is_recording_started'?: boolean;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof IStatusInfo
     */
    'errors'?: { [key: string]: string; };
    /**
     * 
     * @type {string}
     * @memberof IStatusInfo
     */
    'current_selected_model': string;
}
/**
 * 
 * @export
 * @interface ISystemStats
 */
export interface ISystemStats {
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'cpu_count': number;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'cpu_count_threads': number;
    /**
     * 
     * @type {Array<any>}
     * @memberof ISystemStats
     */
    'cpu_usage': Array<any>;
    /**
     * 
     * @type {Array<any>}
     * @memberof ISystemStats
     */
    'cpu_usage_percent': Array<any>;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'disk_total': number;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'disk_used': number;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'disk_percent_used': number;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'ram_total': number;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'ram_available': number;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'ram_used_percent': number;
    /**
     * 
     * @type {number}
     * @memberof ISystemStats
     */
    'ram_free': number;
    /**
     * 
     * @type {string}
     * @memberof ISystemStats
     */
    'eth0'?: string;
    /**
     * 
     * @type {string}
     * @memberof ISystemStats
     */
    'wlan0'?: string;
}
/**
 * 
 * @export
 * @interface IValidationError
 */
export interface IValidationError {
    /**
     * 
     * @type {Array<ILocationInner>}
     * @memberof IValidationError
     */
    'loc': Array<ILocationInner>;
    /**
     * 
     * @type {string}
     * @memberof IValidationError
     */
    'msg': string;
    /**
     * 
     * @type {string}
     * @memberof IValidationError
     */
    'type': string;
}

/**
 * DefaultApi - axios parameter creator
 * @export
 */
export const DefaultApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Read Root
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        readRootGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DefaultApi - functional programming interface
 * @export
 */
export const DefaultApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DefaultApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Read Root
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async readRootGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IDummyItem>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.readRootGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * DefaultApi - factory interface
 * @export
 */
export const DefaultApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DefaultApiFp(configuration)
    return {
        /**
         * 
         * @summary Read Root
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        readRootGet(options?: any): AxiosPromise<IDummyItem> {
            return localVarFp.readRootGet(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * DefaultApi - object-oriented interface
 * @export
 * @class DefaultApi
 * @extends {BaseAPI}
 */
export class DefaultApi extends BaseAPI {
    /**
     * 
     * @summary Read Root
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public readRootGet(options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).readRootGet(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * VehicleApi - axios parameter creator
 * @export
 */
export const VehicleApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * activate model for self driving
         * @summary Activate Model
         * @param {IModelFolder} iModelFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        activateModelApiModelsActivatePost: async (iModelFolder: IModelFolder, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'iModelFolder' is not null or undefined
            assertParamExists('activateModelApiModelsActivatePost', 'iModelFolder', iModelFolder)
            const localVarPath = `/api/models/activate`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(iModelFolder, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Model Folder
         * @param {IModelFolder} iModelFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteModelFolderApiModelsRemoveDelete: async (iModelFolder: IModelFolder, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'iModelFolder' is not null or undefined
            assertParamExists('deleteModelFolderApiModelsRemoveDelete', 'iModelFolder', iModelFolder)
            const localVarPath = `/api/models/remove`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(iModelFolder, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * return requested directory
         * @summary Delete Records Folder
         * @param {IRecordingFolder} iRecordingFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteRecordsFolderApiRecordingsRemoveDelete: async (iRecordingFolder: IRecordingFolder, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'iRecordingFolder' is not null or undefined
            assertParamExists('deleteRecordsFolderApiRecordingsRemoveDelete', 'iRecordingFolder', iRecordingFolder)
            const localVarPath = `/api/recordings/remove`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(iRecordingFolder, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Container logs
         * @summary Docker Container Log
         * @param {string} containerId 
         * @param {number} sinceNanoSeconds 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet: async (containerId: string, sinceNanoSeconds: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'containerId' is not null or undefined
            assertParamExists('dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet', 'containerId', containerId)
            // verify required parameter 'sinceNanoSeconds' is not null or undefined
            assertParamExists('dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet', 'sinceNanoSeconds', sinceNanoSeconds)
            const localVarPath = `/api/containers/{container_id}/{since_nano_seconds}`
                .replace(`{${"container_id"}}`, encodeURIComponent(String(containerId)))
                .replace(`{${"since_nano_seconds"}}`, encodeURIComponent(String(sinceNanoSeconds)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Container list with statuses
         * @summary Docker Containers
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        dockerContainersApiContainersGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/containers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * return requested directory
         * @summary Download Model Folder
         * @param {string} path 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        downloadModelFolderApiModelsDownloadPathGet: async (path: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'path' is not null or undefined
            assertParamExists('downloadModelFolderApiModelsDownloadPathGet', 'path', path)
            const localVarPath = `/api/models/download/{path}`
                .replace(`{${"path"}}`, encodeURIComponent(String(path)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * return requested directory
         * @summary Download Records Folder
         * @param {string} path 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        downloadRecordsFolderApiRecordingsDownloadPathGet: async (path: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'path' is not null or undefined
            assertParamExists('downloadRecordsFolderApiRecordingsDownloadPathGet', 'path', path)
            const localVarPath = `/api/recordings/download/{path}`
                .replace(`{${"path"}}`, encodeURIComponent(String(path)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * flip recording switch (on/off)
         * @summary Flip Recording Switch
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        flipRecordingSwitchApiSwitchRecordingPost: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/switch-recording`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * List of recording folders
         * @summary List Recording Folders
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listRecordingFoldersApiRecordingsListGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/recordings/list`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get list of available models.
         * @summary Models List
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        modelsListApiModelsGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/models`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * reset Emergency Stop
         * @summary Reset Emergency
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        resetEmergencyApiResetEmergencyPost: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/reset-emergency`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * switch driving mode (self-driving vs manual)
         * @summary Switch Driving Mode Endpoint
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        switchDrivingModeEndpointApiSwitchDrivingModePost: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/switch-driving-mode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * upload model file / zip
         * @summary Upload Model
         * @param {File} file 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        uploadModelApiUploadModelPost: async (file: File, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'file' is not null or undefined
            assertParamExists('uploadModelApiUploadModelPost', 'file', file)
            const localVarPath = `/api/upload-model`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new ((configuration && configuration.formDataCtor) || FormData)();


            if (file !== undefined) { 
                localVarFormParams.append('file', file as any);
            }
    
    
            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Return vehicle status
         * @summary Vehicle Local Stats Response
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        vehicleLocalStatsResponseApiStatsGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/stats`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Return system stats
         * @summary Vehicle System Stats Response
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        vehicleSystemStatsResponseApiSystemStatsGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/system/stats`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VehicleApi - functional programming interface
 * @export
 */
export const VehicleApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = VehicleApiAxiosParamCreator(configuration)
    return {
        /**
         * activate model for self driving
         * @summary Activate Model
         * @param {IModelFolder} iModelFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async activateModelApiModelsActivatePost(iModelFolder: IModelFolder, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IStatusInfo>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.activateModelApiModelsActivatePost(iModelFolder, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Model Folder
         * @param {IModelFolder} iModelFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteModelFolderApiModelsRemoveDelete(iModelFolder: IModelFolder, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteModelFolderApiModelsRemoveDelete(iModelFolder, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * return requested directory
         * @summary Delete Records Folder
         * @param {IRecordingFolder} iRecordingFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteRecordsFolderApiRecordingsRemoveDelete(iRecordingFolder: IRecordingFolder, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteRecordsFolderApiRecordingsRemoveDelete(iRecordingFolder, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Container logs
         * @summary Docker Container Log
         * @param {string} containerId 
         * @param {number} sinceNanoSeconds 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet(containerId: string, sinceNanoSeconds: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IContainerLog>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet(containerId, sinceNanoSeconds, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Container list with statuses
         * @summary Docker Containers
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async dockerContainersApiContainersGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IContainerInfo>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.dockerContainersApiContainersGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * return requested directory
         * @summary Download Model Folder
         * @param {string} path 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async downloadModelFolderApiModelsDownloadPathGet(path: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.downloadModelFolderApiModelsDownloadPathGet(path, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * return requested directory
         * @summary Download Records Folder
         * @param {string} path 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async downloadRecordsFolderApiRecordingsDownloadPathGet(path: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.downloadRecordsFolderApiRecordingsDownloadPathGet(path, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * flip recording switch (on/off)
         * @summary Flip Recording Switch
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async flipRecordingSwitchApiSwitchRecordingPost(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IStatusInfo>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.flipRecordingSwitchApiSwitchRecordingPost(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * List of recording folders
         * @summary List Recording Folders
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listRecordingFoldersApiRecordingsListGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IRecordingFolder>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listRecordingFoldersApiRecordingsListGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get list of available models.
         * @summary Models List
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async modelsListApiModelsGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IModelFolder>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.modelsListApiModelsGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * reset Emergency Stop
         * @summary Reset Emergency
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async resetEmergencyApiResetEmergencyPost(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IStatusInfo>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.resetEmergencyApiResetEmergencyPost(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * switch driving mode (self-driving vs manual)
         * @summary Switch Driving Mode Endpoint
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async switchDrivingModeEndpointApiSwitchDrivingModePost(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IStatusInfo>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.switchDrivingModeEndpointApiSwitchDrivingModePost(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * upload model file / zip
         * @summary Upload Model
         * @param {File} file 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async uploadModelApiUploadModelPost(file: File, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IStatusInfo>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.uploadModelApiUploadModelPost(file, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Return vehicle status
         * @summary Vehicle Local Stats Response
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async vehicleLocalStatsResponseApiStatsGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IStatusInfo>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.vehicleLocalStatsResponseApiStatsGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Return system stats
         * @summary Vehicle System Stats Response
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async vehicleSystemStatsResponseApiSystemStatsGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ISystemStats>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.vehicleSystemStatsResponseApiSystemStatsGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * VehicleApi - factory interface
 * @export
 */
export const VehicleApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = VehicleApiFp(configuration)
    return {
        /**
         * activate model for self driving
         * @summary Activate Model
         * @param {IModelFolder} iModelFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        activateModelApiModelsActivatePost(iModelFolder: IModelFolder, options?: any): AxiosPromise<IStatusInfo> {
            return localVarFp.activateModelApiModelsActivatePost(iModelFolder, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Model Folder
         * @param {IModelFolder} iModelFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteModelFolderApiModelsRemoveDelete(iModelFolder: IModelFolder, options?: any): AxiosPromise<any> {
            return localVarFp.deleteModelFolderApiModelsRemoveDelete(iModelFolder, options).then((request) => request(axios, basePath));
        },
        /**
         * return requested directory
         * @summary Delete Records Folder
         * @param {IRecordingFolder} iRecordingFolder 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteRecordsFolderApiRecordingsRemoveDelete(iRecordingFolder: IRecordingFolder, options?: any): AxiosPromise<any> {
            return localVarFp.deleteRecordsFolderApiRecordingsRemoveDelete(iRecordingFolder, options).then((request) => request(axios, basePath));
        },
        /**
         * Container logs
         * @summary Docker Container Log
         * @param {string} containerId 
         * @param {number} sinceNanoSeconds 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet(containerId: string, sinceNanoSeconds: number, options?: any): AxiosPromise<IContainerLog> {
            return localVarFp.dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet(containerId, sinceNanoSeconds, options).then((request) => request(axios, basePath));
        },
        /**
         * Container list with statuses
         * @summary Docker Containers
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        dockerContainersApiContainersGet(options?: any): AxiosPromise<Array<IContainerInfo>> {
            return localVarFp.dockerContainersApiContainersGet(options).then((request) => request(axios, basePath));
        },
        /**
         * return requested directory
         * @summary Download Model Folder
         * @param {string} path 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        downloadModelFolderApiModelsDownloadPathGet(path: string, options?: any): AxiosPromise<any> {
            return localVarFp.downloadModelFolderApiModelsDownloadPathGet(path, options).then((request) => request(axios, basePath));
        },
        /**
         * return requested directory
         * @summary Download Records Folder
         * @param {string} path 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        downloadRecordsFolderApiRecordingsDownloadPathGet(path: string, options?: any): AxiosPromise<any> {
            return localVarFp.downloadRecordsFolderApiRecordingsDownloadPathGet(path, options).then((request) => request(axios, basePath));
        },
        /**
         * flip recording switch (on/off)
         * @summary Flip Recording Switch
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        flipRecordingSwitchApiSwitchRecordingPost(options?: any): AxiosPromise<IStatusInfo> {
            return localVarFp.flipRecordingSwitchApiSwitchRecordingPost(options).then((request) => request(axios, basePath));
        },
        /**
         * List of recording folders
         * @summary List Recording Folders
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listRecordingFoldersApiRecordingsListGet(options?: any): AxiosPromise<Array<IRecordingFolder>> {
            return localVarFp.listRecordingFoldersApiRecordingsListGet(options).then((request) => request(axios, basePath));
        },
        /**
         * get list of available models.
         * @summary Models List
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        modelsListApiModelsGet(options?: any): AxiosPromise<Array<IModelFolder>> {
            return localVarFp.modelsListApiModelsGet(options).then((request) => request(axios, basePath));
        },
        /**
         * reset Emergency Stop
         * @summary Reset Emergency
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        resetEmergencyApiResetEmergencyPost(options?: any): AxiosPromise<IStatusInfo> {
            return localVarFp.resetEmergencyApiResetEmergencyPost(options).then((request) => request(axios, basePath));
        },
        /**
         * switch driving mode (self-driving vs manual)
         * @summary Switch Driving Mode Endpoint
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        switchDrivingModeEndpointApiSwitchDrivingModePost(options?: any): AxiosPromise<IStatusInfo> {
            return localVarFp.switchDrivingModeEndpointApiSwitchDrivingModePost(options).then((request) => request(axios, basePath));
        },
        /**
         * upload model file / zip
         * @summary Upload Model
         * @param {File} file 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        uploadModelApiUploadModelPost(file: File, options?: any): AxiosPromise<IStatusInfo> {
            return localVarFp.uploadModelApiUploadModelPost(file, options).then((request) => request(axios, basePath));
        },
        /**
         * Return vehicle status
         * @summary Vehicle Local Stats Response
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        vehicleLocalStatsResponseApiStatsGet(options?: any): AxiosPromise<IStatusInfo> {
            return localVarFp.vehicleLocalStatsResponseApiStatsGet(options).then((request) => request(axios, basePath));
        },
        /**
         * Return system stats
         * @summary Vehicle System Stats Response
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        vehicleSystemStatsResponseApiSystemStatsGet(options?: any): AxiosPromise<ISystemStats> {
            return localVarFp.vehicleSystemStatsResponseApiSystemStatsGet(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * VehicleApi - object-oriented interface
 * @export
 * @class VehicleApi
 * @extends {BaseAPI}
 */
export class VehicleApi extends BaseAPI {
    /**
     * activate model for self driving
     * @summary Activate Model
     * @param {IModelFolder} iModelFolder 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public activateModelApiModelsActivatePost(iModelFolder: IModelFolder, options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).activateModelApiModelsActivatePost(iModelFolder, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Model Folder
     * @param {IModelFolder} iModelFolder 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public deleteModelFolderApiModelsRemoveDelete(iModelFolder: IModelFolder, options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).deleteModelFolderApiModelsRemoveDelete(iModelFolder, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * return requested directory
     * @summary Delete Records Folder
     * @param {IRecordingFolder} iRecordingFolder 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public deleteRecordsFolderApiRecordingsRemoveDelete(iRecordingFolder: IRecordingFolder, options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).deleteRecordsFolderApiRecordingsRemoveDelete(iRecordingFolder, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Container logs
     * @summary Docker Container Log
     * @param {string} containerId 
     * @param {number} sinceNanoSeconds 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet(containerId: string, sinceNanoSeconds: number, options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).dockerContainerLogApiContainersContainerIdSinceNanoSecondsGet(containerId, sinceNanoSeconds, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Container list with statuses
     * @summary Docker Containers
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public dockerContainersApiContainersGet(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).dockerContainersApiContainersGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * return requested directory
     * @summary Download Model Folder
     * @param {string} path 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public downloadModelFolderApiModelsDownloadPathGet(path: string, options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).downloadModelFolderApiModelsDownloadPathGet(path, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * return requested directory
     * @summary Download Records Folder
     * @param {string} path 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public downloadRecordsFolderApiRecordingsDownloadPathGet(path: string, options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).downloadRecordsFolderApiRecordingsDownloadPathGet(path, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * flip recording switch (on/off)
     * @summary Flip Recording Switch
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public flipRecordingSwitchApiSwitchRecordingPost(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).flipRecordingSwitchApiSwitchRecordingPost(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * List of recording folders
     * @summary List Recording Folders
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public listRecordingFoldersApiRecordingsListGet(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).listRecordingFoldersApiRecordingsListGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get list of available models.
     * @summary Models List
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public modelsListApiModelsGet(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).modelsListApiModelsGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * reset Emergency Stop
     * @summary Reset Emergency
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public resetEmergencyApiResetEmergencyPost(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).resetEmergencyApiResetEmergencyPost(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * switch driving mode (self-driving vs manual)
     * @summary Switch Driving Mode Endpoint
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public switchDrivingModeEndpointApiSwitchDrivingModePost(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).switchDrivingModeEndpointApiSwitchDrivingModePost(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * upload model file / zip
     * @summary Upload Model
     * @param {File} file 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public uploadModelApiUploadModelPost(file: File, options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).uploadModelApiUploadModelPost(file, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Return vehicle status
     * @summary Vehicle Local Stats Response
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public vehicleLocalStatsResponseApiStatsGet(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).vehicleLocalStatsResponseApiStatsGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Return system stats
     * @summary Vehicle System Stats Response
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleApi
     */
    public vehicleSystemStatsResponseApiSystemStatsGet(options?: AxiosRequestConfig) {
        return VehicleApiFp(this.configuration).vehicleSystemStatsResponseApiSystemStatsGet(options).then((request) => request(this.axios, this.basePath));
    }
}


